if (isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
   if (!$RTB::RTBR_ServerControl_Hook)
		exec("Add-Ons/System_ReturnToBlockland/RTBR_ServerControl_Hook.cs");

	RTB_registerPref("Speed Potion Timeout", "Speed Potion", 
		"$Pref::Server::SpeedPotion::Timeout", "int 0 60", "Item_SpeedPotion", 3, 0, 0);

	RTB_registerPref("Speed Potion Multiplier", "Speed Potion", 
		"$Pref::Server::SpeedPotion::Multiplier", "int 0 100", "Item_SpeedPotion", 2, 0, 0);
}

if ($Pref::Server::SpeedPotion::Timeout $= "")
	$Pref::Server::SpeedPotion::Timeout = 3;

if ($Pref::Server::SpeedPotion::Multiplier $= "")
	$Pref::Server::SpeedPotion::Multiplier = 2;

datablock ParticleData(SpeedPotionParticle : PlayerTeleportParticleB)
{
   textureName = "base/data/particles/dot";
   animTexName[0] = "base/data/particles/dot";
   colors[0] = "0.192157 0.607843 0.886275 0.000000";
   colors[1] = "0.266667 0.666667 1.000000 1.000000";
   colors[2] = "0.192157 0.607843 0.886275 0.000000";
   colors[3] = "1.000000 1.000000 1.000000 1.000000";
   times[0] = "0";
   times[1] = "0.25";
   times[2] = "0.5";
   times[3] = "1";
};

datablock ParticleEmitterData(SpeedPotionEmitter : PlayerTeleportEmitterB)
{
	particles = "SpeedPotionParticle";
	lifetimeMS = "0";
	lifetimeVarianceMS = "0";
	useEmitterSizes = "0";
	useEmitterColors = "0";
	uiName = "Speed Potion";
	doFalloff = "0";
	doDetail = "0";
};

datablock ExplosionData(SpeedPotionExplosion)
{
	emitter[0] = "SpeedPotionEmitter";
	uiName = "Speed Potion Explosion";
};

datablock ItemData(SpeedPotionItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./speedPotion.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Speed Potion";
	iconName = "./icon_speedPotion";
	doColorShift = false;

	 // Dynamic properties defined by the scripts
	image = SpeedPotionImage;
	canDrop = true;
};

datablock ShapeBaseImageData(SpeedPotionImage)
{
	// Basic Item properties
	shapeFile = "./speedPotion.dts";
	emap = true;

	// Specify mount point & offset for 3rd person, and eye offset
	// for first person rendering.
	mountPoint = 0;
	offset = "0.09 -0.07 -0.2";
	eyeOffset = 0; //"0.7 1.2 -0.5";
	rotation = eulerToMatrix( "0 0 0" );

	className = "WeaponImage";
	item = SpeedPotionItem;

	//raise your arm up or not
	armReady = true;

	doColorShift = false;

	// Initial start up state
	stateName[0]							= "Ready";
	stateTransitionOnTriggerDown[0]  = "Fire";
	stateAllowImageChange[0]			= true;

	stateName[1]							= "Fire";
	stateTransitionOnTimeout[1]		= "Ready";
	stateAllowImageChange[1]			= true;
	stateScript[1]						 = "onFire";
	stateTimeoutValue[1]			= 1;
};

datablock ShapeBaseImageData(SpeedPotionEmoteImage)
{
	shapeFile = "base/data/shapes/empty.dts";
	emap = false;

	mountPoint = $Chest0;

	stateName[0]					= "Ready";
	stateTransitionOnTimeout[0]		= "FireA";
	stateTimeoutValue[0]			= 0.01;

	stateName[1]					= "FireA";
	stateTransitionOnTimeout[1]		= "Done";
	stateWaitForTimeout[1]			= true;
	stateTimeoutValue[1]			= 0.350;
	stateEmitter[1]					= SpeedPotionEmitter;
	stateEmitterTime[1]				= 0.350;

	stateName[2]					= "Done";
	stateScript[2]					= "onDone";
};

function SpeedPotionEmoteImage::onDone(%this, %obj, %slot)
{
	%obj.unMountImage(%slot);
}

datablock AudioProfile(SpeedPotionDrinkSound)
{
	 fileName = "./drink.wav";
	 description = AudioClosest3d;
	 preload = true;
};

function SpeedPotionImage::onFire(%this, %obj, %slot)
{
	%maxTools = %obj.getDataBlock().maxTools;

	for(%i = 0; %i < %maxTools; %i++)
	{
		%currSlot = %obj.tool[%i];

		if (%currSlot == %this.item.getId())
		{
			%obj.tool[%i] = 0;
			%obj.weaponCount--;
			messageClient(%obj.client, 'MsgItemPickup', '', %i, 0);
			serverCmdUnUseTool(%obj.client);
			break;
		}
	}
	ServerPlay3d(SpeedPotionDrinkSound, %obj.getTransform());

	if (isEventPending(%obj.speedPotionTimeout))
		return;

	%obj.emote(SpeedPotionEmoteImage, 1);

	%mfs = %obj.getMaxForwardSpeed();
	%mbs = %obj.getMaxBackwardSpeed();
	%mss = %obj.getMaxSideSpeed();

	%obj.lastForwardSpeed  = %mfs;
	%obj.lastBackwardSpeed = %mbs;
	%obj.lastSideSpeed	  = %mss;

	%obj.setMaxForwardSpeed(mCeil(%mfs * $Pref::Server::SpeedPotion::Multiplier));
	%obj.setMaxBackwardSpeed(mCeil(%mbs * $Pref::Server::SpeedPotion::Multiplier));
	%obj.setMaxSideSpeed(mCeil(%mss * $Pref::Server::SpeedPotion::Multiplier));

	%obj.speedPotionTimeout = %obj.schedule($Pref::Server::SpeedPotion::Timeout * 1000, 
		SpeedPotionTimeout);
}

function Player::SpeedPotionTimeout(%this)
{
	%mfs = %this.lastForwardSpeed;
	%mbs = %this.lastBackwardSpeed;
	%mss = %this.lastSideSpeed;

	if (%mfs $= "")
		%mfs = 7;

	if (%mbs $= "")
		%mbs = 4;

	if (%mss $= "")
		%mss = 6;

	%this.setMaxForwardSpeed(%mfs);
	%this.setMaxBackwardSpeed(%mbs);
	%this.setMaxSideSpeed(%mss);
}